Manages the API keys associated with developer projects.

A [Model Context Protocol (MCP) server](https://modelcontextprotocol.io/docs/learn/server-concepts) acts as a proxy between an external service that provides context, data, or capabilities to a Large Language Model (LLM) or AI application. MCP servers connect AI applications to external systems such as databases and web services, translating their responses into a format that the AI application can understand.

### Server Setup


You must [enable MCP servers](https://docs.cloud.google.com/mcp/enable-disable-mcp-servers) and [set up authentication](https://docs.cloud.google.com/mcp/authenticate-mcp) before use. For more information about using Google and Google Cloud remote MCP servers, see [Google Cloud MCP servers overview](https://docs.cloud.google.com/mcp/overview).

### Server Endpoints

An MCP service endpoint is the network address and communication interface (usually a URL) of the MCP server that an AI application (the Host for the MCP client) uses to establish a secure, standardized connection. It is the point of contact for the LLM to request context, call a tool, or access a resource. Google MCP endpoints can be global or regional.

The API Keys API MCP server has the following global MCP endpoint:

- https://apikeys.googleapis.com/mcp

## MCP Tools

An [MCP tool](https://modelcontextprotocol.io/legacy/concepts/tools) is a function or executable capability that an MCP server exposes to a LLM or AI application to perform an action in the real world.

### Tools

The apikeys.googleapis.com MCP server has the following tools:

| MCP Tools ||
|---|---|
| `https://docs.cloud.google.com/api-keys/docs/reference/mcp/tools_list/apikeys_list_keys` | Lists the API keys owned by a project, including their metadata and restrictions. |
| `https://docs.cloud.google.com/api-keys/docs/reference/mcp/tools_list/apikeys_get_key` | Gets the metadata for a specific API key. Does not return the key string itself. |
| `https://docs.cloud.google.com/api-keys/docs/reference/mcp/tools_list/apikeys_get_key_string` | Retrieves the actual secret API key string. Treat as highly sensitive. |
| `https://docs.cloud.google.com/api-keys/docs/reference/mcp/tools_list/apikeys_create_key` | Creates a new API key in the specified project. You can optionally specify restrictions. |
| `https://docs.cloud.google.com/api-keys/docs/reference/mcp/tools_list/apikeys_update_key` | Updates the metadata, restrictions, or display name of an existing API key. |
| `https://docs.cloud.google.com/api-keys/docs/reference/mcp/tools_list/apikeys_delete_key` | Deletes an API key. The key can be restored using UndeleteKey within 30 days. |
| `https://docs.cloud.google.com/api-keys/docs/reference/mcp/tools_list/apikeys_undelete_key` | Restores an API key that was recently deleted. |
| `https://docs.cloud.google.com/api-keys/docs/reference/mcp/tools_list/apikeys_lookup_key` | Finds the parent project and resource name of the API key that matches the key string in the request. |

### Get MCP tool specifications


To get the MCP tool specifications for all tools in an MCP server, use the `tools/list` method. The following example demonstrates how to use `curl` to list all tools and their specifications currently available within the MCP server.

| Curl Request |
|---|
| ```bash curl --location 'https://apikeys.googleapis.com/mcp' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/list", "jsonrpc": "2.0", "id": 1 }' ``` |